Enhanced ECS function tests
[nonrtric.git] / test / common / testcase_common.sh
index 4d89d0c..dd9e57a 100755 (executable)
 #
 
 # This is a script that contains all the functions needed for auto test
-# Arg: local|remote|remote-remove [auto-clean]
+# Arg: local|remote|remote-remove [auto-clean] [--stop-at-error] [--ricsim-prefix <prefix> ] [ --env-file <environment-filename> ] [--use-local-image <app-nam> [<app-name>]*]
 
 
+# Create a test case id, ATC (Auto Test Case), from the name of the test case script.
+# FTC1.sh -> ATC == FTC1
+ATC=$(basename "${BASH_SOURCE[$i+1]}" .sh)
+
+#Create result file (containing '1' for error) for this test case
+#Will be replaced with a file containing '0' if all test cases pass
+echo "1" > "$PWD/.result$ATC.txt"
+
 #Formatting for 'echo' cmd
 BOLD="\033[1m"
 EBOLD="\033[0m"
@@ -52,37 +60,18 @@ fi
 # Just resetting any previous echo formatting...
 echo -ne $EBOLD
 
-# source test environment variables
-. ../common/test_env.sh
+# default test environment variables
+TEST_ENV_VAR_FILE=""
 
 echo "Test case started as: ${BASH_SOURCE[$i+1]} "$@
 
-#Vars for A1 interface version and container count
-G1_A1_VERSION=""
-G2_A1_VERSION=""
-G3_A1_VERSION=""
-G1_COUNT=0
-G2_COUNT=0
-G3_COUNT=0
-
-# Vars to switch between http and https. Extra curl flag needed for https
-export RIC_SIM_HTTPX="http"
-export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
-export RIC_SIM_PORT=$RIC_SIM_INTERNAL_PORT
-export RIC_SIM_CERT_MOUNT_DIR="./cert"
-
-export MR_HTTPX="http"
-export MR_PORT=$MR_INTERNAL_PORT
-export MR_LOCAL_PORT=$MR_EXTERNAL_PORT #When agent is running outside the docker net
-
-export SDNC_HTTPX="http"
-export SDNC_PORT=$SDNC_INTERNAL_PORT
-export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT #When agent is running outside the docker net
-
 #Localhost constant
 LOCALHOST="http://localhost:"
 
-# Make curl retries for http response codes set in this env var, space separated list of codes
+# Make curl retries towards ECS for http response codes set in this env var, space separated list of codes
+ECS_RETRY_CODES=""
+
+# Make curl retries towards the agent for http response codes set in this env var, space separated list of codes
 AGENT_RETRY_CODES=""
 
 # Var to contol if the agent runs in a container (normal = 0) or as application on the local machine ( = 1)
@@ -94,9 +83,18 @@ AUTO_CLEAN=""
 # Var to hold the app names to use local image for when running 'remote' or 'remote-remove'
 USE_LOCAL_IMAGES=""
 
+# List of available apps to override with local image
+AVAILABLE_LOCAL_IMAGES_OVERRIDE="PA ECS CP SDNC RICSIM"
+
 # Use this var (STOP_AT_ERROR=1 in the test script) for debugging/trouble shooting to take all logs and exit at first FAIL test case
 STOP_AT_ERROR=0
 
+# Function to indent cmd output with one space
+indent1() { sed 's/^/ /'; }
+
+# Function to indent cmd output with two spaces
+indent2() { sed 's/^/  /'; }
+
 # Set a description string for the test case
 if [ -z "$TC_ONELINE_DESCR" ]; then
        TC_ONELINE_DESCR="<no-description>"
@@ -110,28 +108,37 @@ if [ -f .tmp_tcsuite_ctr ]; then
        echo $tmpval > .tmp_tcsuite_ctr
 fi
 
-# Create a test case id, ATC (Auto Test Case), from the name of the test case script.
-# FTC1.sh -> ATC == FTC1
-ATC=$(basename "${BASH_SOURCE[$i+1]}" .sh)
-
 # Create the logs dir if not already created in the current dir
 if [ ! -d "logs" ]; then
     mkdir logs
 fi
 TESTLOGS=$PWD/logs
 
+# Create the tmp dir for temporary files that is not needed after the test
+# hidden files for the test env is still stored in the current dir
+if [ ! -d "tmp" ]; then
+    mkdir tmp
+fi
+
 # Create a http message log for this testcase
 HTTPLOG=$PWD"/.httplog_"$ATC".txt"
 echo "" > $HTTPLOG
 
-#Create result file (containing '1' for error) for this test case
-#Will be replaced with a file containing '0' if script is ok
-
-echo "1" > "$PWD/.result$ATC.txt"
 
 # Create a log dir for the test case
 mkdir -p $TESTLOGS/$ATC
 
+# Save create for current logs
+mkdir -p $TESTLOGS/$ATC/previous
+
+rm $TESTLOGS/$ATC/previous/*.log &> /dev/null
+rm $TESTLOGS/$ATC/previous/*.txt &> /dev/null
+rm $TESTLOGS/$ATC/previous/*.json &> /dev/null
+
+mv  $TESTLOGS/$ATC/*.log $TESTLOGS/$ATC/previous &> /dev/null
+mv  $TESTLOGS/$ATC/*.txt $TESTLOGS/$ATC/previous &> /dev/null
+mv  $TESTLOGS/$ATC/*.txt $TESTLOGS/$ATC/previous &> /dev/null
+
 # Clear the log dir for the test case
 rm $TESTLOGS/$ATC/*.log &> /dev/null
 rm $TESTLOGS/$ATC/*.txt &> /dev/null
@@ -152,6 +159,94 @@ RES_DEVIATION=0
 DEVIATION_FILE=".tmp_deviations"
 rm $DEVIATION_FILE &> /dev/null
 
+
+# Trap "command not found" and make the script fail
+trap_fnc() {
+
+       if [ $? -eq 127 ]; then
+               echo -e $RED"Function not found, set script to FAIL"$ERED
+               ((RES_CONF_FAIL++))
+       fi
+}
+trap trap_fnc ERR
+
+# Counter for tests
+TEST_SEQUENCE_NR=1
+
+__log_test_start() {
+       TIMESTAMP=$(date "+%Y-%m-%d %H:%M:%S")
+       echo -e $BOLD"TEST $TEST_SEQUENCE_NR (${BASH_LINENO[1]}): ${FUNCNAME[1]}" $@ $EBOLD
+    echo "TEST $TEST_SEQUENCE_NR - ${TIMESTAMP}: (${BASH_LINENO[1]}): ${FUNCNAME[1]}" $@ >> $HTTPLOG
+       ((RES_TEST++))
+       ((TEST_SEQUENCE_NR++))
+}
+
+__log_test_fail_general() {
+       echo -e $RED" FAIL."$1 $ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_fail_status_code() {
+       echo -e $RED" FAIL. Exepected status "$1", got "$2 $3 $ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_fail_body() {
+       echo -e $RED" FAIL, returned body not correct"$ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_fail_not_supported() {
+       echo -e $RED" FAIL, function not supported"$ERED
+       ((RES_FAIL++))
+       __check_stop_at_error
+}
+
+__log_test_pass() {
+       if [ $# -gt 0 ]; then
+               echo $@
+       fi
+       ((RES_PASS++))
+       echo -e $GREEN" PASS"$EGREEN
+}
+
+#Counter for configurations
+CONF_SEQUENCE_NR=1
+__log_conf_start() {
+       TIMESTAMP=$(date "+%Y-%m-%d %H:%M:%S")
+       echo -e $BOLD"CONF $CONF_SEQUENCE_NR (${BASH_LINENO[1]}): "${FUNCNAME[1]} $@ $EBOLD
+       echo "CONF $CONF_SEQUENCE_NR - ${TIMESTAMP}: (${BASH_LINENO[1]}): "${FUNCNAME[1]} $@  >> $HTTPLOG
+       ((CONF_SEQUENCE_NR++))
+}
+
+__log_conf_fail_general() {
+       echo -e $RED" FAIL."$1 $ERED
+       ((RES_CONF_FAIL++))
+       __check_stop_at_error
+}
+
+__log_conf_fail_status_code() {
+       echo -e $RED" FAIL. Exepected status "$1", got "$2 $3 $ERED
+       ((RES_CONF_FAIL++))
+       __check_stop_at_error
+}
+
+__log_conf_fail_body() {
+       echo -e $RED" FAIL, returned body not correct"$ERED
+       ((RES_CONF_FAIL++))
+       __check_stop_at_error
+}
+
+__log_conf_ok() {
+       if [ $# -gt 0 ]; then
+               echo $@
+       fi
+       echo -e $GREEN" OK"$EGREEN
+}
+
 #Var for measuring execution time
 TCTEST_START=$SECONDS
 
@@ -180,59 +275,172 @@ if [ $paramerror -eq 0 ]; then
                shift;
        fi
 fi
-if [ $paramerror -eq 0 ]; then
-       if [ "$1" == "auto-clean" ]; then
-               AUTO_CLEAN="auto"
-               shift;
+foundparm=0
+while [ $paramerror -eq 0 ] && [ $foundparm -eq 0 ]; do
+       foundparm=1
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "auto-clean" ]; then
+                       AUTO_CLEAN="auto"
+                       echo "Option set - Auto clean at end of test script"
+                       shift;
+                       foundparm=0
+               fi
        fi
-fi
-if [ $paramerror -eq 0 ]; then
-       if [ "$1" == "--stop-at-error" ]; then
-               STOP_AT_ERROR=1
-               shift;
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--stop-at-error" ]; then
+                       STOP_AT_ERROR=1
+                       echo "Option set - Stop at first error"
+                       shift;
+                       foundparm=0
+               fi
        fi
-fi
-if [ $paramerror -eq 0 ]; then
-       if [ "$1" == "--use-local-image" ]; then
-               USE_LOCAL_IMAGES=${@:2}
-               while [ $# -gt 0 ]; do
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--ricsim-prefix" ]; then
                        shift;
-               done
+                       RIC_SIM_PREFIX=$1
+                       if [ -z "$1" ]; then
+                               paramerror=1
+                       else
+                               echo "Option set - Overriding RIC_SIM_PREFIX with: "$1
+                               shift;
+                               foundparm=0
+                       fi
+               fi
        fi
-fi
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--env-file" ]; then
+                       shift;
+                       TEST_ENV_VAR_FILE=$1
+                       if [ -z "$1" ]; then
+                               paramerror=1
+                       else
+                               echo "Option set - Reading test env from: "$1
+                               shift;
+                               foundparm=0
+                       fi
+               fi
+       fi
+       if [ $paramerror -eq 0 ]; then
+               if [ "$1" == "--use-local-image" ]; then
+                       USE_LOCAL_IMAGES=""
+                       shift
+                       while [ $# -gt 0 ] && [[ "$1" != "--"* ]]; do
+                               USE_LOCAL_IMAGES=$USE_LOCAL_IMAGES" "$1
+                               if [[ "$AVAILABLE_LOCAL_IMAGES_OVERRIDE" != *"$1"* ]]; then
+                                       paramerror=1
+                               fi
+                               shift;
+                       done
+                       foundparm=0
+                       if [ -z "$USE_LOCAL_IMAGES" ]; then
+                               paramerror=1
+                       else
+                               echo "Option set - Override remote images for app(s):"$USE_LOCAL_IMAGES
+                       fi
+               fi
+       fi
+done
+echo ""
 
+#Still params left?
 if [ $paramerror -eq 0 ] && [ $# -gt 0 ]; then
        paramerror=1
 fi
 
 if [ $paramerror -eq 1 ]; then
-       echo -e $RED"Expected arg: local|remote|remote-remove [auto-clean] [--stop-at-error] [--use-local-image <app-nam> [<app-name>]*]"$ERED
+       echo -e $RED"Expected arg: local|remote|remote-remove [auto-clean] [--stop-at-error] [--ricsim-prefix <prefix> ] [ --env-file <environment-filename> ] [--use-local-image <app-nam> [<app-name>]*]"$ERED
+       exit 1
+fi
+
+# sourcing the selected env variables for the test case
+if [ -f "$TEST_ENV_VAR_FILE" ]; then
+       echo -e $BOLD"Sourcing env vars from: "$TEST_ENV_VAR_FILE$EBOLD
+       . $TEST_ENV_VAR_FILE
+
+       if [ -z "$TEST_ENV_PROFILE" ] || [ -z "$SUPPORTED_PROFILES" ]; then
+               echo -e $YELLOW"This test case may no work with selected test env file. TEST_ENV_PROFILE is missing in test_env file or SUPPORTED_PROFILES is missing in test case file"$EYELLOW
+       else
+               if [[ "$SUPPORTED_PROFILES" == *"$TEST_ENV_PROFILE"* ]]; then
+                       echo -e $GREEN"Test case support the selected test env file"$EGREEN
+               else
+                       echo -e $RED"Test case does not support the selected test env file"$ERED
+                       echo -e $RED"Exiting...."$ERED
+                       exit 1
+               fi
+       fi
+else
+       echo -e $RED"Selected env var file does not exist: "$TEST_ENV_VAR_FILE$ERED
+       echo " Select one of following env var file matching the intended target of the test"
+       echo " Restart the test using the flag '--env-file <path-to-env-file>"
+       ls ../common/test_env* | indent1
        exit 1
 fi
 
+#Vars for A1 interface version and container count
+G1_A1_VERSION=""
+G2_A1_VERSION=""
+G3_A1_VERSION=""
+G4_A1_VERSION=""
+G5_A1_VERSION=""
+G1_COUNT=0
+G2_COUNT=0
+G3_COUNT=0
+G4_COUNT=0
+G5_COUNT=0
+
+# Vars to switch between http and https. Extra curl flag needed for https
+export RIC_SIM_HTTPX="http"
+export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
+export RIC_SIM_PORT=$RIC_SIM_INTERNAL_PORT
+export RIC_SIM_CERT_MOUNT_DIR="./cert"
+
+export MR_HTTPX="http"
+export MR_PORT=$MR_INTERNAL_PORT
+export MR_LOCAL_PORT=$MR_EXTERNAL_PORT #When agent is running outside the docker net
+
+export CR_HTTPX="http"
+export CR_PORT=$CR_INTERNAL_PORT
+export CR_LOCAL_PORT=$CR_EXTERNAL_PORT #When CR is running outside the docker net
+export CR_PATH="$CR_HTTPX://$CR_APP_NAME:$CR_PORT$CR_APP_CALLBACK"
+
+export PROD_STUB_HTTPX="http"
+export PROD_STUB_PORT=$PROD_STUB_INTERNAL_PORT
+export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_PORT #When CR is running outside the docker net
+export PROD_STUB_LOCALHOST=$PROD_STUB_HTTPX"://localhost:"$PROD_STUB_LOCAL_PORT
+
+export SDNC_HTTPX="http"
+export SDNC_PORT=$SDNC_INTERNAL_PORT
+export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT #When agent is running outside the docker net
+
 echo -e $BOLD"Checking configured image setting for this test case"$EBOLD
 
 #Temp var to check for image variable name errors
 IMAGE_ERR=0
 #Create a file with image info for later printing as a table
-image_list_file=".image-list"
+image_list_file="./tmp/.image-list"
 echo -e " Container\tImage\ttag" > $image_list_file
 
 # Check if image env var is set and if so export the env var with image to use (used by docker compose files)
-# arg: <image name> <script start-arg> <target-variable-name> <image-variable-name> <image-tag-variable-name>
+# arg: <image name> <script start-arg> <target-variable-name> <image-variable-name> <image-tag-variable-name> <app-short-name>
 __check_image_var() {
-       if [ $# -ne 5 ]; then
-               echo "Expected arg: <image name> <script start-arg> <target-variable-name> <image-variable-name> <image-tag-variable-name>"
+       if [ $# -ne 6 ]; then
+               echo "Expected arg: <image name> <script start-arg> <target-variable-name> <image-variable-name> <image-tag-variable-name> <app-short-name>"
                ((IMAGE_ERR++))
                return
        fi
+       __check_included_image $6
+       if [ $? -ne 0 ]; then
+               echo -e "$1\t<image-excluded>\t<no-tag>"  >> $image_list_file
+               # Image is excluded since the corresponding app is not used in this test
+               return
+       fi
        tmp=${1}"\t"
        #Create var from the input var names
        image="${!4}"
        tag="${!5}"
 
        if [ -z $image ]; then
-               echo -e $RED"\$"$4" not set in test_env"$ERED
+               echo -e $RED"\$"$4" not set in $TEST_ENV_VAR_FILE"$ERED
                ((IMAGE_ERR++))
                echo ""
                tmp=$tmp"<no-image>\t"
@@ -240,7 +448,7 @@ __check_image_var() {
                tmp=$tmp$image"\t"
        fi
        if [ -z $tag ]; then
-               echo -e $RED"\$"$5" not set in test_env"$ERED
+               echo -e $RED"\$"$5" not set in $TEST_ENV_VAR_FILE"$ERED
                ((IMAGE_ERR++))
                echo ""
                tmp=$tmp"<no-tag>\t"
@@ -256,6 +464,7 @@ __check_image_var() {
 
 
 #Check if app local image shall override remote image
+# Possible IDs for local image override: PA, CP, SDNC, RICSIM, ECS
 __check_image_local_override() {
        for im in $USE_LOCAL_IMAGES; do
                if [ "$1" == "$im" ]; then
@@ -265,14 +474,16 @@ __check_image_local_override() {
        return 0
 }
 
-#Check if app uses image excluded from this test run
-__check_excluded_image() {
-       for im in $EXCLUDED_IMAGES; do
+# Check if app uses image included in this test run
+# Returns 0 if image is included, 1 if not
+# Possible IDs for image inclusion: CBS, CONSUL, CP, CR, ECS, MR, PA, PRODSTUB, RICSIM, SDNC
+__check_included_image() {
+       for im in $INCLUDED_IMAGES; do
                if [ "$1" == "$im" ]; then
-                       return 1
+                       return 0
                fi
        done
-       return 0
+       return 1
 }
 
 # Check that image env setting are available
@@ -281,53 +492,62 @@ echo ""
 if [ $START_ARG == "local" ]; then
 
        #Local agent image
-       __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG"
+       __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG" PA
 
        #Local Control Panel image
-       __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG"
+       __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG" CP
 
        #Local SNDC image
-       __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG"
+       __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG" SDNC
 
        #Local ric sim image
-       __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG"
+       __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG" RICSIM
 
 elif [ $START_ARG == "remote" ] || [ $START_ARG == "remote-remove" ]; then
 
        __check_image_local_override 'PA'
        if [ $? -eq 0 ]; then
                #Remote agent image
-               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_REMOTE_IMAGE" "POLICY_AGENT_REMOTE_IMAGE_TAG"
+               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_REMOTE_IMAGE" "POLICY_AGENT_REMOTE_IMAGE_TAG" PA
        else
                #Local agent image
-               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG"
+               __check_image_var " Policy Agent" $START_ARG "POLICY_AGENT_IMAGE" "POLICY_AGENT_LOCAL_IMAGE" "POLICY_AGENT_LOCAL_IMAGE_TAG" PA
        fi
 
        __check_image_local_override 'CP'
        if [ $? -eq 0 ]; then
                #Remote Control Panel image
-               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE_TAG"
+               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE" "CONTROL_PANEL_REMOTE_IMAGE_TAG" CP
        else
                #Local Control Panel image
-               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG"
+               __check_image_var " Control Panel" $START_ARG "CONTROL_PANEL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE" "CONTROL_PANEL_LOCAL_IMAGE_TAG" CP
        fi
 
        __check_image_local_override 'SDNC'
        if [ $? -eq 0 ]; then
                #Remote SDNC image
-               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE_TAG"
+               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE" "SDNC_A1_CONTROLLER_REMOTE_IMAGE_TAG" SDNC
        else
                #Local SNDC image
-               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG"
+               __check_image_var " SDNC A1 Controller" $START_ARG "SDNC_A1_CONTROLLER_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE" "SDNC_A1_CONTROLLER_LOCAL_IMAGE_TAG" SDNC
        fi
 
        __check_image_local_override 'RICSIM'
        if [ $? -eq 0 ]; then
                #Remote ric sim image
-               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_REMOTE_IMAGE" "RIC_SIM_REMOTE_IMAGE_TAG"
+               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_REMOTE_IMAGE" "RIC_SIM_REMOTE_IMAGE_TAG" RICSIM
        else
                #Local ric sim image
-               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG"
+               __check_image_var " RIC Simulator" $START_ARG "RIC_SIM_IMAGE" "RIC_SIM_LOCAL_IMAGE" "RIC_SIM_LOCAL_IMAGE_TAG" RICSIM
+       fi
+
+       __check_image_local_override 'ECS'
+       if [ $? -eq 0 ]; then
+               #Remote ecs image
+               __check_image_var " ECS" $START_ARG "ECS_IMAGE" "ECS_REMOTE_IMAGE" "ECS_REMOTE_IMAGE_TAG" ECS
+       else
+               #Local ecs image
+               __check_image_var " ECS" $START_ARG "ECS_IMAGE" "ECS_LOCAL_IMAGE" "ECS_LOCAL_IMAGE_TAG" ECS
        fi
 
 else
@@ -338,16 +558,12 @@ fi
 
 
 # These images are not built as part of this project official images, just check that env vars are set correctly
-__check_image_var " Message Router" $START_ARG "MRSTUB_IMAGE" "MRSTUB_LOCAL_IMAGE" "MRSTUB_LOCAL_IMAGE_TAG"
-__check_image_var " Callback Receiver" $START_ARG "CR_IMAGE" "CR_LOCAL_IMAGE" "CR_LOCAL_IMAGE_TAG"
-__check_image_var " Consul" $START_ARG "CONSUL_IMAGE" "CONSUL_REMOTE_IMAGE" "CONSUL_REMOTE_IMAGE_TAG"
-__check_image_var " CBS" $START_ARG "CBS_IMAGE" "CBS_REMOTE_IMAGE" "CBS_REMOTE_IMAGE_TAG"
-__check_image_var " SDNC DB" $START_ARG "SDNC_DB_IMAGE" "SDNC_DB_REMOTE_IMAGE" "SDNC_DB_REMOTE_IMAGE_TAG"
-__check_excluded_image 'SDNC_ONAP'
-if [ $? -eq 0 ]; then
-       __check_image_var " SDNC ONAP A1 Adapter" $START_ARG "SDNC_ONAP_A1_ADAPTER_IMAGE" "SDNC_ONAP_A1_ADAPTER_REMOTE_IMAGE" "SDNC_ONAP_A1_ADAPTER_REMOTE_IMAGE_TAG"
-       __check_image_var " SDNC ONAP DB" $START_ARG "SDNC_ONAP_DB_IMAGE" "SDNC_ONAP_DB_REMOTE_IMAGE" "SDNC_ONAP_DB_REMOTE_IMAGE_TAG"
-fi
+__check_image_var " Message Router" $START_ARG "MRSTUB_IMAGE" "MRSTUB_LOCAL_IMAGE" "MRSTUB_LOCAL_IMAGE_TAG" MR
+__check_image_var " Callback Receiver" $START_ARG "CR_IMAGE" "CR_LOCAL_IMAGE" "CR_LOCAL_IMAGE_TAG" CR
+__check_image_var " Producer stub" $START_ARG "PROD_STUB_IMAGE" "PROD_STUB_LOCAL_IMAGE" "PROD_STUB_LOCAL_IMAGE_TAG" PRODSTUB
+__check_image_var " Consul" $START_ARG "CONSUL_IMAGE" "CONSUL_REMOTE_IMAGE" "CONSUL_REMOTE_IMAGE_TAG" CONSUL
+__check_image_var " CBS" $START_ARG "CBS_IMAGE" "CBS_REMOTE_IMAGE" "CBS_REMOTE_IMAGE_TAG" CBS
+__check_image_var " SDNC DB" $START_ARG "SDNC_DB_IMAGE" "SDNC_DB_REMOTE_IMAGE" "SDNC_DB_REMOTE_IMAGE_TAG" SDNC #Uses sdnc app name
 
 #Errors in image setting - exit
 if [ $IMAGE_ERR -ne 0 ]; then
@@ -367,13 +583,13 @@ if [ -z "$SIM_GROUP" ]; then
        SIM_GROUP=$PWD/../simulator-group
        if [ ! -d  $SIM_GROUP ]; then
                echo "Trying to set env var SIM_GROUP to dir 'simulator-group' in the nontrtric repo, but failed."
-               echo -e $RED"Please set the SIM_GROUP manually in the test_env.sh"$ERED
+               echo -e $RED"Please set the SIM_GROUP manually in the applicable $TEST_ENV_VAR_FILE"$ERED
                exit 1
        else
                echo " SIM_GROUP auto set to: " $SIM_GROUP
        fi
 elif [ $SIM_GROUP = *simulator_group ]; then
-       echo -e $RED"Env var SIM_GROUP does not seem to point to dir 'simulator-group' in the repo, check common/test_env.sh"$ERED
+       echo -e $RED"Env var SIM_GROUP does not seem to point to dir 'simulator-group' in the repo, check $TEST_ENV_VAR_FILE"$ERED
        exit 1
 else
        echo " SIM_GROUP env var already set to: " $SIM_GROUP
@@ -405,24 +621,24 @@ __check_and_pull_image() {
                        echo -ne "  Attempt to stop and remove container(s), if running - ${SAMELINE}"
                        tmp="$(docker ps -aq --filter name=${3})"
                        if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker stop $tmp &> .dockererr
+                               docker stop $tmp &> ./tmp/.dockererr
                                if [ $? -ne 0 ]; then
                                        ((IMAGE_ERR++))
                                        echo ""
                                        echo -e $RED"  Container(s) could not be stopped - try manual stopping the container(s)"$ERED
-                                       cat .dockererr
+                                       cat ./tmp/.dockererr
                                        return 1
                                fi
                        fi
                        echo -ne "  Attempt to stop and remove container(s), if running - "$GREEN"stopped"$EGREEN"${SAMELINE}"
                        tmp="$(docker ps -aq --filter name=${3})" &> /dev/null
                        if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker rm $tmp &> .dockererr
+                               docker rm $tmp &> ./tmp/.dockererr
                                if [ $? -ne 0 ]; then
                                        ((IMAGE_ERR++))
                                        echo ""
                                        echo -e $RED"  Container(s) could not be removed - try manual removal of the container(s)"$ERED
-                                       cat .dockererr
+                                       cat ./tmp/.dockererr
                                        return 1
                                fi
                        fi
@@ -430,12 +646,12 @@ __check_and_pull_image() {
                        echo -ne "  Removing image - ${SAMELINE}"
                        tmp="$(docker images -q ${4})" &> /dev/null
                        if [ $? -eq 0 ] && [ ! -z "$tmp" ]; then
-                               docker rmi $4 &> .dockererr
+                               docker rmi --force $4 &> ./tmp/.dockererr
                                if [ $? -ne 0 ]; then
                                        ((IMAGE_ERR++))
                                        echo ""
                                        echo -e $RED"  Image could not be removed - try manual removal of the image"$ERED
-                                       cat .dockererr
+                                       cat ./tmp/.dockererr
                                        return 1
                                fi
                                echo -e "  Removing image - "$GREEN"removed"$EGREEN
@@ -446,13 +662,13 @@ __check_and_pull_image() {
                fi
                if [ -z "$tmp_im" ]; then
                        echo -ne "  Pulling image${SAMELINE}"
-                       docker pull $4  &> .dockererr
+                       docker pull $4  &> ./tmp/.dockererr
                        tmp_im=$(docker images ${4} | grep -v REPOSITORY)
                        if [ -z "$tmp_im" ]; then
                                echo ""
                                echo -e "  Pulling image -$RED could not be pulled"$ERED
                                ((IMAGE_ERR++))
-                               cat .dockererr
+                               cat ./tmp/.dockererr
                                return 1
                        fi
                        echo -e "  Pulling image -$GREEN Pulled $EGREEN"
@@ -466,51 +682,81 @@ __check_and_pull_image() {
 
 echo -e $BOLD"Pulling configured images, if needed"$EBOLD
 
-START_ARG_MOD=$START_ARG
-__check_image_local_override 'PA'
-if [ $? -eq 1 ]; then
-       START_ARG_MOD="local"
+__check_included_image 'PA'
+if [ $? -eq 0 ]; then
+       START_ARG_MOD=$START_ARG
+       __check_image_local_override 'PA'
+       if [ $? -eq 1 ]; then
+               START_ARG_MOD="local"
+       fi
+       app="Policy Agent";             __check_and_pull_image $START_ARG_MOD "$app" $POLICY_AGENT_APP_NAME $POLICY_AGENT_IMAGE
+else
+       echo -e $YELLOW" Excluding PA image from image check/pull"$EYELLOW
 fi
-app="Policy Agent";             __check_and_pull_image $START_ARG_MOD "$app" $POLICY_AGENT_APP_NAME $POLICY_AGENT_IMAGE
 
-START_ARG_MOD=$START_ARG
-__check_image_local_override 'CP'
-if [ $? -eq 1 ]; then
-       START_ARG_MOD="local"
+__check_included_image 'ECS'
+if [ $? -eq 0 ]; then
+       START_ARG_MOD=$START_ARG
+       __check_image_local_override 'ECS'
+       if [ $? -eq 1 ]; then
+               START_ARG_MOD="local"
+       fi
+       app="ECS";             __check_and_pull_image $START_ARG_MOD "$app" $ECS_APP_NAME $ECS_IMAGE
+else
+       echo -e $YELLOW" Excluding ECS image from image check/pull"$EYELLOW
 fi
-app="Non-RT RIC Control Panel"; __check_and_pull_image $START_ARG_MOD "$app" $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_IMAGE
 
-START_ARG_MOD=$START_ARG
-__check_image_local_override 'RICSIM'
-if [ $? -eq 1 ]; then
-       START_ARG_MOD="local"
+__check_included_image 'CP'
+if [ $? -eq 0 ]; then
+       START_ARG_MOD=$START_ARG
+       __check_image_local_override 'CP'
+       if [ $? -eq 1 ]; then
+               START_ARG_MOD="local"
+       fi
+       app="Non-RT RIC Control Panel"; __check_and_pull_image $START_ARG_MOD "$app" $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_IMAGE
+else
+       echo -e $YELLOW" Excluding Non-RT RIC Control Panel image from image check/pull"$EYELLOW
 fi
-app="Near-RT RIC Simulator";    __check_and_pull_image $START_ARG_MOD "$app" $RIC_SIM_PREFIX"_"$RIC_SIM_BASE $RIC_SIM_IMAGE
 
-app="Consul";                   __check_and_pull_image $START_ARG "$app" $CONSUL_APP_NAME $CONSUL_IMAGE
-app="CBS";                      __check_and_pull_image $START_ARG "$app" $CBS_APP_NAME $CBS_IMAGE
-__check_excluded_image 'SDNC'
+__check_included_image 'RICSIM'
 if [ $? -eq 0 ]; then
        START_ARG_MOD=$START_ARG
-       __check_image_local_override 'SDNC'
+       __check_image_local_override 'RICSIM'
        if [ $? -eq 1 ]; then
                START_ARG_MOD="local"
        fi
-       app="SDNC A1 Controller";       __check_and_pull_image $START_ARG_MOD "$app" $SDNC_APP_NAME $SDNC_A1_CONTROLLER_IMAGE
-       app="SDNC DB";                  __check_and_pull_image $START_ARG "$app" $SDNC_APP_NAME $SDNC_DB_IMAGE
+       app="Near-RT RIC Simulator";    __check_and_pull_image $START_ARG_MOD "$app" $RIC_SIM_PREFIX"_"$RIC_SIM_BASE $RIC_SIM_IMAGE
 else
-       echo -e $YELLOW" Excluding SDNC image and related DB image from image check/pull"$EYELLOW
+       echo -e $YELLOW" Excluding Near-RT RIC Simulator image from image check/pull"$EYELLOW
 fi
-__check_excluded_image 'SDNC_ONAP'
+
+
+__check_included_image 'CONSUL'
 if [ $? -eq 0 ]; then
-       app="SDNC ONAP A1 Adapter";     __check_and_pull_image $START_ARG "$app" $SDNC_ONAP_APP_NAME $SDNC_ONAP_A1_ADAPTER_IMAGE
-       app="SDNC ONAP DB";             __check_and_pull_image $START_ARG "$app" $SDNC_ONAP_APP_NAME $SDNC_ONAP_DB_IMAGE
+       app="Consul";                   __check_and_pull_image $START_ARG "$app" $CONSUL_APP_NAME $CONSUL_IMAGE
 else
-       echo -e $YELLOW" Excluding ONAP SDNC image and related DB image from image check/pull"$EYELLOW
+       echo -e $YELLOW" Excluding Consul image from image check/pull"$EYELLOW
 fi
-# MR stub image not checked, will be built by this script - only local image
-# CR stub image not checked, will be built by this script - only local image
 
+__check_included_image 'CBS'
+if [ $? -eq 0 ]; then
+       app="CBS";                      __check_and_pull_image $START_ARG "$app" $CBS_APP_NAME $CBS_IMAGE
+else
+       echo -e $YELLOW" Excluding CBS image from image check/pull"$EYELLOW
+fi
+
+__check_included_image 'SDNC'
+if [ $? -eq 0 ]; then
+       START_ARG_MOD=$START_ARG
+       __check_image_local_override 'SDNC'
+       if [ $? -eq 1 ]; then
+               START_ARG_MOD="local"
+       fi
+       app="SDNC A1 Controller";       __check_and_pull_image $START_ARG_MOD "$app" $SDNC_APP_NAME $SDNC_A1_CONTROLLER_IMAGE
+       app="SDNC DB";                  __check_and_pull_image $START_ARG "$app" $SDNC_APP_NAME $SDNC_DB_IMAGE
+else
+       echo -e $YELLOW" Excluding SDNC image and related DB image from image check/pull"$EYELLOW
+fi
 
 #Errors in image setting - exit
 if [ $IMAGE_ERR -ne 0 ]; then
@@ -528,55 +774,112 @@ echo ""
 echo -e $BOLD"Building images needed for test"$EBOLD
 
 curdir=$PWD
-cd $curdir
-cd ../mrstub
-echo " Building mrstub image: mrstub:latest"
-docker build -t mrstub . &> .dockererr
+__check_included_image 'MR'
 if [ $? -eq 0 ]; then
-       echo -e  $GREEN" Build Ok"$EGREEN
+       cd $curdir
+       cd ../mrstub
+       echo " Building mrstub image: $MRSTUB_LOCAL_IMAGE:$MRSTUB_LOCAL_IMAGE_TAG"
+       docker build  --build-arg NEXUS_PROXY_REPO=$NEXUS_PROXY_REPO -t $MRSTUB_LOCAL_IMAGE . &> .dockererr
+       if [ $? -eq 0 ]; then
+               echo -e  $GREEN" Build Ok"$EGREEN
+       else
+               echo -e $RED" Build Failed"$ERED
+               ((RES_CONF_FAIL++))
+               cat .dockererr
+               echo -e $RED"Exiting...."$ERED
+               exit 1
+       fi
+       cd $curdir
 else
-       echo -e $RED" Build Failed"$ERED
-       ((RES_CONF_FAIL++))
-       cat .dockererr
+       echo -e $YELLOW" Excluding mrstub from image build"$EYELLOW
 fi
-cd $curdir
 
-cd ../cr
-echo " Building Callback Receiver image: callback-receiver:latest"
-docker build -t callback-receiver . &> .dockererr
+__check_included_image 'CR'
 if [ $? -eq 0 ]; then
-       echo -e  $GREEN" Build Ok"$EGREEN
+       cd ../cr
+       echo " Building Callback Receiver image: $CR_LOCAL_IMAGE:$CR_IMAGE_TAG"
+       docker build  --build-arg NEXUS_PROXY_REPO=$NEXUS_PROXY_REPO -t $CR_LOCAL_IMAGE . &> .dockererr
+       if [ $? -eq 0 ]; then
+               echo -e  $GREEN" Build Ok"$EGREEN
+       else
+               echo -e $RED" Build Failed"$ERED
+               ((RES_CONF_FAIL++))
+               cat .dockererr
+               echo -e $RED"Exiting...."$ERED
+               exit 1
+       fi
+       cd $curdir
 else
-       echo -e $RED" Build Failed"$ERED
-       ((RES_CONF_FAIL++))
-       cat .dockererr
+       echo -e $YELLOW" Excluding Callback Receiver from image build"$EYELLOW
+fi
+
+__check_included_image 'PRODSTUB'
+if [ $? -eq 0 ]; then
+       cd ../prodstub
+       echo " Building Producer stub image: $PROD_STUB_LOCAL_IMAGE:$PROD_STUB_LOCAL_IMAGE_TAG"
+       docker build  --build-arg NEXUS_PROXY_REPO=$NEXUS_PROXY_REPO -t $PROD_STUB_LOCAL_IMAGE . &> .dockererr
+       if [ $? -eq 0 ]; then
+               echo -e  $GREEN" Build Ok"$EGREEN
+       else
+               echo -e $RED" Build Failed"$ERED
+               ((RES_CONF_FAIL++))
+               cat .dockererr
+               echo -e $RED"Exiting...."$ERED
+               exit 1
+       fi
+       cd $curdir
+else
+       echo -e $YELLOW" Excluding Producer stub from image build"$EYELLOW
 fi
-cd $curdir
 
 echo ""
 
 # Create a table of the images used in the script
 echo -e $BOLD"Local docker registry images used in the this test script"$EBOLD
 
-docker_tmp_file=.docker-images-table
-format_string="{{.Repository}}\\t{{.Tag}}\\t{{.CreatedSince}}\\t{{.Size}}"
-echo -e " Application\tRepository\tTag\tCreated Since\tSize" > $docker_tmp_file
-echo -e " Policy Agent\t$(docker images --format $format_string $POLICY_AGENT_IMAGE)" >>   $docker_tmp_file
-echo -e " Control Panel\t$(docker images --format $format_string $CONTROL_PANEL_IMAGE)" >>   $docker_tmp_file
-echo -e " RIC Simulator\t$(docker images --format $format_string $RIC_SIM_IMAGE)" >>   $docker_tmp_file
-echo -e " Message Router\t$(docker images --format $format_string $MRSTUB_IMAGE)" >>   $docker_tmp_file
-echo -e " Callback Receiver\t$(docker images --format $format_string $CR_IMAGE)" >>   $docker_tmp_file
-echo -e " Consul\t$(docker images --format $format_string $CONSUL_IMAGE)" >>   $docker_tmp_file
-echo -e " CBS\t$(docker images --format $format_string $CBS_IMAGE)" >>   $docker_tmp_file
-__check_excluded_image 'SDNC'
+docker_tmp_file=./tmp/.docker-images-table
+format_string="{{.Repository}}\\t{{.Tag}}\\t{{.CreatedSince}}\\t{{.Size}}\\t{{.CreatedAt}}"
+echo -e " Application\tRepository\tTag\tCreated since\tSize\tCreated at" > $docker_tmp_file
+__check_included_image 'PA'
 if [ $? -eq 0 ]; then
-       echo -e " SDNC A1 Controller\t$(docker images --format $format_string $SDNC_A1_CONTROLLER_IMAGE)" >>   $docker_tmp_file
-       echo -e " SDNC DB\t$(docker images --format $format_string $SDNC_DB_IMAGE)" >>   $docker_tmp_file
+       echo -e " Policy Agent\t$(docker images --format $format_string $POLICY_AGENT_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'ECS'
+if [ $? -eq 0 ]; then
+       echo -e " ECS\t$(docker images --format $format_string $ECS_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'CP'
+if [ $? -eq 0 ]; then
+       echo -e " Control Panel\t$(docker images --format $format_string $CONTROL_PANEL_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'RICSIM'
+if [ $? -eq 0 ]; then
+       echo -e " RIC Simulator\t$(docker images --format $format_string $RIC_SIM_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'MR'
+if [ $? -eq 0 ]; then
+       echo -e " Message Router\t$(docker images --format $format_string $MRSTUB_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'CR'
+if [ $? -eq 0 ]; then
+       echo -e " Callback Receiver\t$(docker images --format $format_string $CR_IMAGE)" >>   $docker_tmp_file
 fi
-__check_excluded_image 'SDNC_ONAP'
+__check_included_image 'PRODSTUB'
 if [ $? -eq 0 ]; then
-       echo -e " SDNC ONAP A1 Adapter\t$(docker images --format $format_string $SDNC_ONAP_A1_ADAPTER_IMAGE)" >>   $docker_tmp_file
-       echo -e " SDNC ONAP DB\t$(docker images --format $format_string $SDNC_ONAP_DB_IMAGE)" >>   $docker_tmp_file
+       echo -e " Produccer stub\t$(docker images --format $format_string $PROD_STUB_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'CONSUL'
+if [ $? -eq 0 ]; then
+       echo -e " Consul\t$(docker images --format $format_string $CONSUL_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'CBS'
+if [ $? -eq 0 ]; then
+       echo -e " CBS\t$(docker images --format $format_string $CBS_IMAGE)" >>   $docker_tmp_file
+fi
+__check_included_image 'SDNC'
+if [ $? -eq 0 ]; then
+       echo -e " SDNC A1 Controller\t$(docker images --format $format_string $SDNC_A1_CONTROLLER_IMAGE)" >>   $docker_tmp_file
+       echo -e " SDNC DB\t$(docker images --format $format_string $SDNC_DB_IMAGE)" >>   $docker_tmp_file
 fi
 
 column -t -s $'\t' $docker_tmp_file
@@ -602,6 +905,7 @@ print_result() {
        echo "-------------------------------------------------------------------------------------------------"
        echo "-- Description: "$TC_ONELINE_DESCR
        echo "-- Execution time: " $duration " seconds"
+       echo "-- Used env file: "$TEST_ENV_VAR_FILE
        echo "-------------------------------------------------------------------------------------------------"
        echo "-------------------------------------     RESULTS"
        echo ""
@@ -769,6 +1073,15 @@ __check_stop_at_error() {
        return 0
 }
 
+# Check if app name var is set. If so return the app name otherwise return "NOTSET"
+__check_app_name() {
+       if [ $# -eq 1 ]; then
+               echo $1
+       else
+               echo "NOTSET"
+       fi
+}
+
 # Stop and remove all containers
 # args: -
 # (Function for test scripts)
@@ -776,20 +1089,21 @@ clean_containers() {
 
        echo -e $BOLD"Stopping and removing all running containers, by container name"$EBOLD
 
-       CONTAINTER_NAMES=("Policy Agent           " $POLICY_AGENT_APP_NAME\
-                                         "Non-RT RIC Simulator(s)" $RIC_SIM_PREFIX\
-                                         "Message Router         " $MR_APP_NAME\
-                                         "Callback Receiver      " $CR_APP_NAME\
-                                         "Control Panel          " $CONTROL_PANEL_APP_NAME\
-                                         "SDNC A1 Controller     " $SDNC_APP_NAME\
-                                         "SDNC DB                " $SDNC_DB_APP_NAME\
-                                         "SDNC ONAP A1 Adapter   " $SDNC_ONAP_APP_NAME\
-                                         "SDNC DB                " $SDNC_ONAP_DB_APP_NAME\
-                                         "CBS                    " $CBS_APP_NAME\
-                                         "Consul                 " $CONSUL_APP_NAME)
+       CONTAINTER_NAMES=("Policy Agent           " $(__check_app_name $POLICY_AGENT_APP_NAME)\
+                                         "ECS                    " $(__check_app_name $ECS_APP_NAME)\
+                                         "Non-RT RIC Simulator(s)" $(__check_app_name $RIC_SIM_PREFIX)\
+                                         "Message Router         " $(__check_app_name $MR_APP_NAME)\
+                                         "Callback Receiver      " $(__check_app_name $CR_APP_NAME)\
+                                         "Producer stub          " $(__check_app_name $PROD_STUB_APP_NAME)\
+                                         "Control Panel          " $(__check_app_name $CONTROL_PANEL_APP_NAME)\
+                                         "SDNC A1 Controller     " $(__check_app_name $SDNC_APP_NAME)\
+                                         "SDNC DB                " $(__check_app_name $SDNC_DB_APP_NAME)\
+                                         "CBS                    " $(__check_app_name $CBS_APP_NAME)\
+                                         "Consul                 " $(__check_app_name $CONSUL_APP_NAME))
 
        nw=0 # Calc max width of container name, to make a nice table
        for (( i=1; i<${#CONTAINTER_NAMES[@]} ; i+=2 )) ; do
+
                if [ ${#CONTAINTER_NAMES[i]} -gt $nw ]; then
                        nw=${#CONTAINTER_NAMES[i]}
                fi
@@ -798,14 +1112,16 @@ clean_containers() {
        for (( i=0; i<${#CONTAINTER_NAMES[@]} ; i+=2 )) ; do
                APP="${CONTAINTER_NAMES[i]}"
                CONTR="${CONTAINTER_NAMES[i+1]}"
-               for((w=${#CONTR}; w<$nw; w=w+1)); do
-                       CONTR="$CONTR "
-               done
-               echo -ne " $APP: $CONTR - ${GREEN}stopping${EGREEN}${SAMELINE}"
-               docker stop $(docker ps -qa --filter name=${CONTR}) &> /dev/null
-               echo -ne " $APP: $CONTR - ${GREEN}stopped${EGREEN}${SAMELINE}"
-               docker rm --force $(docker ps -qa --filter name=${CONTR}) &> /dev/null
-               echo -e  " $APP: $CONTR - ${GREEN}stopped removed${EGREEN}"
+               if [ $CONTR != "NOTSET" ]; then
+                       for((w=${#CONTR}; w<$nw; w=w+1)); do
+                               CONTR="$CONTR "
+                       done
+                       echo -ne " $APP: $CONTR - ${GREEN}stopping${EGREEN}${SAMELINE}"
+                       docker stop $(docker ps -qa --filter name=${CONTR}) &> /dev/null
+                       echo -ne " $APP: $CONTR - ${GREEN}stopped${EGREEN}${SAMELINE}"
+                       docker rm --force $(docker ps -qa --filter name=${CONTR}) &> /dev/null
+                       echo -e  " $APP: $CONTR - ${GREEN}stopped removed${EGREEN}"
+               fi
        done
 
        echo ""
@@ -813,22 +1129,35 @@ clean_containers() {
        echo -e $BOLD" Removing docker network"$EBOLD
        TMP=$(docker network ls -q --filter name=$DOCKER_SIM_NWNAME)
        if [ "$TMP" ==  $DOCKER_SIM_NWNAME ]; then
-               docker network rm $DOCKER_SIM_NWNAME
+               docker network rm $DOCKER_SIM_NWNAME | indent2
                if [ $? -ne 0 ];  then
                        echo -e $RED" Cannot remove docker network. Manually remove or disconnect containers from $DOCKER_SIM_NWNAME"$ERED
                        exit 1
                fi
        fi
+       echo -e "$GREEN  Done$EGREEN"
 
        echo -e $BOLD" Removing all unused docker neworks"$EBOLD
-       docker network prune --force #&> /dev/null
+       docker network prune --force | indent2
+       echo -e "$GREEN  Done$EGREEN"
 
        echo -e $BOLD" Removing all unused docker volumes"$EBOLD
-       docker volume prune --force #&> /dev/null
+       docker volume prune --force | indent2
+       echo -e "$GREEN  Done$EGREEN"
 
        echo -e $BOLD" Removing all dangling/untagged docker images"$EBOLD
     docker rmi --force $(docker images -q -f dangling=true) &> /dev/null
+       echo -e "$GREEN  Done$EGREEN"
        echo ""
+
+       CONTRS=$(docker ps | awk '$1 != "CONTAINER" { n++ }; END { print n+0 }')
+       if [ $? -eq 0 ]; then
+               if [ $CONTRS -ne 0 ]; then
+                       echo -e $RED"Containers running, may cause distubance to the test case"$ERED
+                       docker ps -a | indent1
+                       echo ""
+               fi
+       fi
 }
 
 # Function stop and remove all container in the end of the test script, if the arg 'auto-clean' is given at test script start
@@ -872,6 +1201,7 @@ __print_err() {
        if [ $# -gt 1 ]; then
                echo -e $RED" Got: "${FUNCNAME[1]} ${@:2} $ERED
        fi
+       ((RES_CONF_FAIL++))
 }
 
 
@@ -898,11 +1228,13 @@ __create_docker_network() {
                return 1
        fi
        if [ "$tmp" != $DOCKER_SIM_NWNAME ]; then
-               echo -e "Creating docker network:$BOLD $DOCKER_SIM_NWNAME $EBOLD"
-               docker network create $DOCKER_SIM_NWNAME
+               echo -e " Creating docker network:$BOLD $DOCKER_SIM_NWNAME $EBOLD"
+               docker network create $DOCKER_SIM_NWNAME | indent2
                if [ $? -ne 0 ]; then
                        echo -e $RED" Could not create docker network $DOCKER_SIM_NWNAME"$ERED
                        return 1
+               else
+                       echo -e "$GREEN  Done$EGREEN"
                fi
        else
                echo -e " Docker network $DOCKER_SIM_NWNAME already exists$GREEN OK $EGREEN"
@@ -943,7 +1275,8 @@ __check_container_start() {
                        ((RES_CONF_FAIL++))
                        echo ""
                        echo -e $RED" Container $BOLD${appname}$EBOLD could not be started"$ERED
-                       return 1
+                       echo -e $RED" Stopping script..."$ERED
+                       exit 1
                fi
                if [ $localport -eq 0 ]; then
                        while [ $localport -eq 0 ]; do
@@ -978,7 +1311,7 @@ __check_container_start() {
                else
                        TS_TMP=$SECONDS
                        while [ $(($TS_TMP+$i)) -gt $SECONDS ]; do
-                               echo -ne " Waiting for container ${appname} service status...retrying in $(($TS_TMP+$i-$SECONDS)) seconds   ${SAMELINE}"
+                               echo -ne " Waiting for container ${appname} service status...$(($SECONDS-$TSTART)) seconds, retrying in $(($TS_TMP+$i-$SECONDS)) seconds   ${SAMELINE}"
                                sleep 1
                        done
                fi
@@ -986,7 +1319,7 @@ __check_container_start() {
 
        if [ "$pa_st" = "false"  ]; then
                ((RES_CONF_FAIL++))
-               echo -e $RED" Container ${appname} did not respond to service status"$ERED
+               echo -e $RED" Container ${appname} did not respond to service status in $(($SECONDS-$TSTART)) seconds"$ERED
                return 0
        fi
 
@@ -1017,6 +1350,8 @@ __start_container() {
                if [ $? -ne 0 ]; then
                        echo -e $RED"Problem to launch container(s) with docker-compose"$ERED
                        cat .dockererr
+                       echo -e $RED"Stopping script...."$ERED
+                       exit 1
                fi
        elif [ "$2" == "STANDALONE" ]; then
                echo "Skipping docker-compose"
@@ -1025,6 +1360,8 @@ __start_container() {
                if [ $? -ne 0 ]; then
                        echo -e $RED"Problem to launch container(s) with docker-compose"$ERED
                        cat .dockererr
+                       echo -e $RED"Stopping script...."$ERED
+                       exit 1
                fi
        fi
        app_prefix=""
@@ -1048,6 +1385,13 @@ __start_container() {
        return 0
 }
 
+# Generate a UUID to use as prefix for policy ids
+generate_uuid() {
+       UUID=$(python3 -c 'import sys,uuid; sys.stdout.write(uuid.uuid4().hex)')
+       #Reduce length to make space for serial id, us 'a' as marker where the serial id is added
+       UUID=${UUID:0:${#UUID}-4}"a"
+}
+
 ####################
 ### Consul functions
 ####################
@@ -1067,14 +1411,15 @@ consul_config_app() {
 
        echo " Loading config for "$POLICY_AGENT_APP_NAME" from "$1
 
-       curl -s $LOCALHOST${CONSUL_EXTERNAL_PORT}/v1/kv/${POLICY_AGENT_APP_NAME}?dc=dc1 -X PUT -H 'Accept: application/json' -H 'Content-Type: application/json' -H 'X-Requested-With: XMLHttpRequest' --data-binary "@"$1 >/dev/null
+       curlString="$LOCALHOST${CONSUL_EXTERNAL_PORT}/v1/kv/${POLICY_AGENT_APP_NAME}?dc=dc1 -X PUT -H Accept:application/json -H Content-Type:application/json -H X-Requested-With:XMLHttpRequest --data-binary @"$1
+       result=$(__do_curl "$curlString")
        if [ $? -ne 0 ]; then
                echo -e $RED" FAIL - json config could not be loaded to consul" $ERED
                ((RES_CONF_FAIL++))
                return 1
        fi
        body="$(__do_curl $LOCALHOST$CBS_EXTERNAL_PORT/service_component_all/$POLICY_AGENT_APP_NAME)"
-       echo $body > ".output"$1
+       echo $body > "./tmp/.output"$1
 
        if [ $? -ne 0 ]; then
                echo -e $RED" FAIL - json config could not be loaded from consul/cbs, contents cannot be checked." $ERED
@@ -1099,7 +1444,7 @@ consul_config_app() {
 }
 
 # Function to perpare the consul configuration according to the current simulator configuration
-# args: SDNC|SDNC_ONAP|NOSDNC <output-file>
+# args: SDNC|NOSDNC <output-file>
 # (Function for test scripts)
 prepare_consul_config() {
        echo -e $BOLD"Prepare Consul config"$EBOLD
@@ -1108,19 +1453,17 @@ prepare_consul_config() {
 
        if [ $# != 2 ];  then
                ((RES_CONF_FAIL++))
-       __print_err "need two args,  SDNC|SDNC_ONAP|NOSDNC <output-file>" $@
+       __print_err "need two args,  SDNC|NOSDNC <output-file>" $@
                exit 1
        fi
 
        if [ $1 == "SDNC" ]; then
                echo -e " Config$BOLD including SDNC$EBOLD configuration"
-       elif [ $1 == "SDNC_ONAP" ]; then
-               echo -e " Config$BOLD including SDNC ONAP$EBOLD configuration"
        elif [ $1 == "NOSDNC" ];  then
-               echo -e " Config$BOLD excluding SDNC or SDNC ONAP$EBOLD configuration"
+               echo -e " Config$BOLD excluding SDNC$EBOLD configuration"
        else
                ((RES_CONF_FAIL++))
-       __print_err "need two args,  SDNC|SDNC_ONAP|NOSDNC <output-file>" $@
+       __print_err "need two args,  SDNC|NOSDNC <output-file>" $@
                exit 1
        fi
 
@@ -1139,21 +1482,6 @@ prepare_consul_config() {
                config_json=$config_json"\n                     }"
                config_json=$config_json"\n   ],"
        fi
-       if [ $1 == "SDNC_ONAP" ]; then
-               config_json=$config_json"\n   \"controller\": ["
-               config_json=$config_json"\n                     {"
-               config_json=$config_json"\n                       \"name\": \"$SDNC_ONAP_APP_NAME\","
-               if [ $AGENT_STAND_ALONE -eq 0 ]; then
-                       config_json=$config_json"\n                       \"baseUrl\": \"http://$SDNC_ONAP_APP_NAME:$SDNC_ONAP_INTERNAL_PORT\","
-               else
-                       config_json=$config_json"\n                       \"baseUrl\": \"http://localhost:$SDNC_ONAP_EXTERNAL_PORT\","
-               fi
-               config_json=$config_json"\n                       \"userName\": \"$SDNC_ONAP_USER\","
-               config_json=$config_json"\n                       \"password\": \"$SDNC_ONAP_PWD\""
-               config_json=$config_json"\n                     }"
-               config_json=$config_json"\n   ],"
-       fi
-
 
        config_json=$config_json"\n   \"streams_publishes\": {"
        config_json=$config_json"\n                            \"dmaap_publisher\": {"
@@ -1182,7 +1510,7 @@ prepare_consul_config() {
 
        config_json=$config_json"\n   \"ric\": ["
 
-       rics=$(docker ps | grep ricsim | awk '{print $NF}')
+       rics=$(docker ps | grep $RIC_SIM_PREFIX | awk '{print $NF}')
 
        if [ $? -ne 0 ] || [ -z "$rics" ]; then
                echo -e $RED" FAIL - the names of the running RIC Simulator cannot be retrieved." $ERED
@@ -1204,8 +1532,6 @@ prepare_consul_config() {
                fi
                if [ $1 == "SDNC" ]; then
                        config_json=$config_json"\n            \"controller\": \"$SDNC_APP_NAME\","
-               elif [ $1 == "SDNC_ONAP" ]; then
-                       config_json=$config_json"\n            \"controller\": \"$SDNC_ONAP_APP_NAME\","
                fi
                config_json=$config_json"\n            \"managedElementIds\": ["
                config_json=$config_json"\n              \"me1_$ric\","
@@ -1231,7 +1557,12 @@ prepare_consul_config() {
 start_consul_cbs() {
 
        echo -e $BOLD"Starting Consul and CBS"$EBOLD
-
+       __check_included_image 'CONSUL'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The Consul image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"Consul will not be started"$ERED
+               exit
+       fi
        __start_container consul_cbs NODOCKERARGS  "$CONSUL_APP_NAME" "$CONSUL_EXTERNAL_PORT" "/ui/dc1/kv" "http" \
                                                     "$CBS_APP_NAME" "$CBS_EXTERNAL_PORT" "/healthcheck" "http"
 }
@@ -1241,7 +1572,8 @@ start_consul_cbs() {
 ###########################
 
 use_simulator_http() {
-       echo -e "Using unsecure $BOLD http $EBOLD towards the simulators"
+       echo -e $BOLD"RICSIM protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards the simulators"
        export RIC_SIM_HTTPX="http"
        export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
        export RIC_SIM_PORT=$RIC_SIM_INTERNAL_PORT
@@ -1249,39 +1581,60 @@ use_simulator_http() {
 }
 
 use_simulator_https() {
-       echo -e "Using secure $BOLD https $EBOLD towards the simulators"
+       echo -e $BOLD"RICSIM protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards the simulators"
        export RIC_SIM_HTTPX="https"
        export RIC_SIM_LOCALHOST=$RIC_SIM_HTTPX"://localhost:"
        export RIC_SIM_PORT=$RIC_SIM_INTERNAL_SECURE_PORT
        echo ""
 }
 
-# Start one group (ricsim_g1, ricsim_g2 or ricsim_g3) with a number of RIC Simulators using a given A interface
-# args:  ricsim_g1|ricsim_g2|ricsim_g3 <count> <interface-id>
+# Start one group (ricsim_g1, ricsim_g2 .. ricsim_g5) with a number of RIC Simulators using a given A interface
+# 'ricsim' may be set on command line to other prefix
+# args:  ricsim_g1|ricsim_g2|ricsim_g3|ricsim_g4|ricsim_g5 <count> <interface-id>
 # (Function for test scripts)
 start_ric_simulators() {
 
        echo -e $BOLD"Starting RIC Simulators"$EBOLD
 
+       __check_included_image 'RICSIM'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The Near-RT RIC Simulator image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"The Near-RT RIC Simulartor(s) will not be started"$ERED
+               exit
+       fi
+
+       RIC1=$RIC_SIM_PREFIX"_g1"
+       RIC2=$RIC_SIM_PREFIX"_g2"
+       RIC3=$RIC_SIM_PREFIX"_g3"
+       RIC4=$RIC_SIM_PREFIX"_g4"
+       RIC5=$RIC_SIM_PREFIX"_g5"
+
        if [ $# != 3 ]; then
                ((RES_CONF_FAIL++))
-       __print_err "need three args,  ricsim_g1|ricsim_g2|ricsim_g3 <count> <interface-id>" $@
+       __print_err "need three args,  $RIC1|$RIC2|$RIC3|$RIC4|$RIC5 <count> <interface-id>" $@
                exit 1
        fi
        echo " $2 simulators using basename: $1 on interface: $3"
        #Set env var for simulator count and A1 interface vesion for the given group
-       if [ $1 == "ricsim_g1" ]; then
+       if [ $1 == "$RIC1" ]; then
                G1_COUNT=$2
                G1_A1_VERSION=$3
-       elif [ $1 == "ricsim_g2" ]; then
+       elif [ $1 == "$RIC2" ]; then
                G2_COUNT=$2
                G2_A1_VERSION=$3
-       elif [ $1 == "ricsim_g3" ]; then
+       elif [ $1 == "$RIC3" ]; then
                G3_COUNT=$2
                G3_A1_VERSION=$3
+       elif [ $1 == "$RIC4" ]; then
+               G4_COUNT=$2
+               G4_A1_VERSION=$3
+       elif [ $1 == "$RIC5" ]; then
+               G5_COUNT=$2
+               G5_A1_VERSION=$3
        else
                ((RES_CONF_FAIL++))
-       __print_err "need three args, gricsim_g1|ricsim_g2|ricsim_g3 <count> <interface-id>" $@
+       __print_err "need three args, $RIC1|$RIC2|$RIC3|$RIC4|$RIC5 <count> <interface-id>" $@
                exit 1
        fi
 
@@ -1291,8 +1644,10 @@ start_ric_simulators() {
        export G1_A1_VERSION
        export G2_A1_VERSION
        export G3_A1_VERSION
+       export G4_A1_VERSION
+       export G5_A1_VERSION
 
-       docker_args="--scale g1=$G1_COUNT --scale g2=$G2_COUNT --scale g3=$G3_COUNT"
+       docker_args="--scale g1=$G1_COUNT --scale g2=$G2_COUNT --scale g3=$G3_COUNT --scale g4=$G4_COUNT --scale g5=$G5_COUNT"
        app_data=""
        cntr=1
        while [ $cntr -le $2 ]; do
@@ -1315,7 +1670,12 @@ start_ric_simulators() {
 start_control_panel() {
 
        echo -e $BOLD"Starting Control Panel"$EBOLD
-
+       __check_included_image 'CP'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The Control Panel image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"The Control Panel will not be started"$ERED
+               exit
+       fi
        __start_container control_panel NODOCKERARGS $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_EXTERNAL_PORT "/" "http"
 
 }
@@ -1331,7 +1691,7 @@ start_sdnc() {
 
        echo -e $BOLD"Starting SDNC A1 Controller"$EBOLD
 
-       __check_excluded_image 'SDNC'
+       __check_included_image 'SDNC'
        if [ $? -eq 1 ]; then
                echo -e $RED"The image for SDNC and the related DB has not been checked for this test run due to arg to the test script"$ERED
                echo -e $RED"SDNC will not be started"$ERED
@@ -1343,7 +1703,8 @@ start_sdnc() {
 }
 
 use_sdnc_http() {
-       echo -e $BOLD"Using http between agent and SDNC"$EBOLD
+       echo -e $BOLD"SDNC protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards SDNC"
        export SDNC_HTTPX="http"
        export SDNC_PORT=$SDNC_INTERNAL_PORT
        export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_PORT
@@ -1351,69 +1712,14 @@ use_sdnc_http() {
 }
 
 use_sdnc_https() {
-       echo -e $BOLD"Using https between agent and SDNC"$EBOLD
+       echo -e $BOLD"SDNC protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards SDNC"
        export SDNC_HTTPX="https"
        export SDNC_PORT=$SDNC_INTERNAL_SECURE_PORT
        export SDNC_LOCAL_PORT=$SDNC_EXTERNAL_SECURE_PORT
        echo ""
 }
 
-#######################
-### SDNC ONAP functions
-#######################
-
-# Start the SDNC ONAP A1 Adapter
-# args: -
-# (Function for test scripts)
-start_sdnc_onap() {
-
-       echo -e $BOLD"Starting SDNC ONAP A1 Adapter"$EBOLD
-
-       __check_excluded_image 'SDNC_ONAP'
-       if [ $? -eq 1 ]; then
-               echo -e $RED"The image for SDNC ONAP and the related DB has not been checked for this test run due to arg to the test script"$ERED
-               echo -e $RED"SDNC ONAP will not be started"$ERED
-               exit
-       fi
-
-       __start_container sdnc_onap NODOCKERARGS $SDNC_ONAP_APP_NAME $SDNC_ONAP_EXTERNAL_PORT $SDNC_ONAP_ALIVE_URL "http"
-
-}
-
-# Configure the SDNC ONAP A1 Adapter
-# args: -
-# (Function for test scripts)
-config_sdnc_onap() {
-
-       echo -e $BOLD"Configuring SDNC ONAP A1 Adapter"$EBOLD
-
-       LOCALFILE=".sdnc_onap.prop"
-       REMOTEFILE="/tmp/.sdnc_onap.prop"
-
-       docker cp $SDNC_ONAP_APP_NAME:$SDNC_ONAP_PROPERTIES_FILE $LOCALFILE
-       if [ $? -ne 0 ]; then
-               echo -e $RED"Could not copy $SDNC_ONAP_PROPERTIES_FILE from $SDNC_ONAP_APP_NAME container"$ERED
-               exit 1
-       fi
-
-
-       #Config of the prop file shall be inserted here
-
-       #Copy file to /tmp and then to final destination, a trick to get correct permission of the file.
-
-       docker cp $LOCALFILE $SDNC_ONAP_APP_NAME:$REMOTEFILE
-       if [ $? -ne 0 ]; then
-               echo -e $RED"Could not copy local $LOCALFILE to $REMOTEFILE in $SDNC_ONAP_APP_NAME container"$ERED
-               exit 1
-       fi
-
-       docker exec -it $SDNC_ONAP_APP_NAME cp $REMOTEFILE $SDNC_ONAP_PROPERTIES_FILE
-       if [ $? -ne 0 ]; then
-               echo -e $RED"Could not copy $REMOTEFILE to $SDNC_ONAP_PROPERTIES_FILE in $SDNC_ONAP_APP_NAME container"$ERED
-               exit 1
-       fi
-}
-
 #####################
 ### MR stub functions
 #####################
@@ -1424,12 +1730,19 @@ config_sdnc_onap() {
 start_mr() {
 
        echo -e $BOLD"Starting Message Router 'mrstub'"$EBOLD
+       __check_included_image 'MR'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The Message Router image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"The Message Router will not be started"$ERED
+               exit
+       fi
        export MR_CERT_MOUNT_DIR="./cert"
        __start_container mr NODOCKERARGS $MR_APP_NAME $MR_EXTERNAL_PORT "/" "http"
 }
 
 use_mr_http() {
-       echo -e $BOLD"Using http between agent and MR"$EBOLD
+       echo -e $BOLD"MR protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards MR"
        export MR_HTTPX="http"
        export MR_PORT=$MR_INTERNAL_PORT
        export MR_LOCAL_PORT=$MR_EXTERNAL_PORT
@@ -1437,7 +1750,8 @@ use_mr_http() {
 }
 
 use_mr_https() {
-       echo -e $BOLD"Using https between agent and MR"$EBOLD
+       echo -e $BOLD"MR protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards MR"
        export MR_HTTPX="https"
        export MR_PORT=$MR_INTERNAL_SECURE_PORT
        export MR_LOCAL_PORT=$MR_EXTERNAL_SECURE_PORT
@@ -1455,11 +1769,76 @@ use_mr_https() {
 start_cr() {
 
        echo -e $BOLD"Starting Callback Receiver"$EBOLD
-
+       __check_included_image 'CR'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The Callback Receiver image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"The Callback Receiver will not be started"$ERED
+               exit
+       fi
        __start_container cr NODOCKERARGS $CR_APP_NAME $CR_EXTERNAL_PORT "/" "http"
 
 }
 
+use_cr_http() {
+       echo -e $BOLD"CR protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards CR"
+       export CR_HTTPX="http"
+       export CR_PORT=$CR_INTERNAL_PORT
+       export CR_LOCAL_PORT=$CR_EXTERNAL_PORT
+       export CR_PATH="$CR_HTTPX://$CR_APP_NAME:$CR_PORT$CR_APP_CALLBACK"
+       echo ""
+}
+
+use_cr_https() {
+       echo -e $BOLD"CR protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards CR"
+       export CR_HTTPX="https"
+       export CR_PORT=$CR_INTERNAL_SECURE_PORT
+       export CR_LOCAL_PORT=$CR_EXTERNAL_SECURE_PORT
+       export CR_PATH="$CR_HTTPX://$CR_APP_NAME:$CR_PORT$CR_APP_CALLBACK"
+       echo ""
+}
+
+###########################
+### Producer stub functions
+###########################
+
+# Start the Producer stub in the simulator group
+# args: -
+# (Function for test scripts)
+start_prod_stub() {
+
+       echo -e $BOLD"Starting Producer stub"$EBOLD
+       __check_included_image 'PRODSTUB'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The Producer stub image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"The Producer stub will not be started"$ERED
+               exit
+       fi
+       __start_container prodstub NODOCKERARGS $PROD_STUB_APP_NAME $PROD_STUB_EXTERNAL_PORT "/" "http"
+
+}
+
+use_prod_stub_http() {
+       echo -e $BOLD"Producer stub protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD towards Producer stub"
+       export PROD_STUB_HTTPX="http"
+       export PROD_STUB_PORT=$PROD_STUB_INTERNAL_PORT
+       export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_PORT
+       export PROD_STUB_LOCALHOST=$PROD_STUB_HTTPX"://localhost:"$PROD_STUB_LOCAL_PORT
+       echo ""
+}
+
+use_prod_stub_https() {
+       echo -e $BOLD"Producer stub protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD towards Producer stub"
+       export PROD_STUB_HTTPX="https"
+       export PROD_STUB_PORT=$PROD_STUB_INTERNAL_SECURE_PORT
+       export PROD_STUB_LOCAL_PORT=$PROD_STUB_EXTERNAL_SECURE_PORT
+       export PROD_STUB_LOCALHOST=$PROD_STUB_HTTPX"://localhost:"$PROD_STUB_LOCAL_PORT
+       echo ""
+}
+
 ###########################
 ### Policy Agents functions
 ###########################
@@ -1477,12 +1856,18 @@ start_policy_agent() {
        echo -e $BOLD"Starting Policy Agent"$EBOLD
 
        if [ $AGENT_STAND_ALONE -eq 0 ]; then
+               __check_included_image 'PA'
+               if [ $? -eq 1 ]; then
+                       echo -e $RED"The Policy Agent image has not been checked for this test run due to arg to the test script"$ERED
+                       echo -e $RED"The Policy Agent will not be started"$ERED
+                       exit
+               fi
                __start_container policy_agent NODOCKERARGS $POLICY_AGENT_APP_NAME $POLICY_AGENT_EXTERNAL_PORT "/status" "http"
        else
                echo -e $RED"The consul config produced by this test script (filename '<fullpath-to-autotest-dir>.output<file-name>"$ERED
                echo -e $RED"where the file name is the file in the consul_config_app command in this script) must be pointed out by the agent "$ERED
                echo -e $RED"application.yaml"$ERED
-               echo -e $RED"The application jar may need to be built beforefor continuing"$ERED
+               echo -e $RED"The application jar may need to be built before continuing"$ERED
                echo -e $RED"The agent shall now be running on port $POLICY_AGENT_EXTERNAL_PORT for http"$ERED
 
                read -p "<press any key to continue>"
@@ -1495,7 +1880,8 @@ start_policy_agent() {
 # args: -
 # (Function for test scripts)
 use_agent_rest_http() {
-       echo -e $BOLD"Using agent REST interface with http"$EBOLD
+       echo -e $BOLD"Agent protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD and $BOLD REST $EBOLD towards the agent"
        export ADAPTER=$RESTBASE
        echo ""
 }
@@ -1504,31 +1890,49 @@ use_agent_rest_http() {
 # args: -
 # (Function for test scripts)
 use_agent_rest_https() {
-       echo -e $BOLD"Using agent REST interface with https"$EBOLD
+       echo -e $BOLD"Agent protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards the agent"
        export ADAPTER=$RESTBASE_SECURE
        echo ""
        return 0
 }
 
-# All calls to the agent will be directed to the agent dmaap interface from now on
+# All calls to the agent will be directed to the agent dmaap interface over http from now on
 # args: -
 # (Function for test scripts)
-use_agent_dmaap() {
-       echo -e $BOLD"Agent using DMAAP interface"$EBOLD
+use_agent_dmaap_http() {
+       echo -e $BOLD"Agent dmaap protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD and $BOLD DMAAP $EBOLD towards the agent"
        export ADAPTER=$DMAAPBASE
        echo ""
        return 0
 }
 
+# All calls to the agent will be directed to the agent dmaap interface over https from now on
+# args: -
+# (Function for test scripts)
+use_agent_dmaap_https() {
+       echo -e $BOLD"Agent dmaap protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD and $BOLD DMAAP $EBOLD towards the agent"
+       export ADAPTER=$DMAAPBASE_SECURE
+       echo ""
+       return 0
+}
 
 # Turn on debug level tracing in the agent
 # args: -
 # (Function for test scripts)
 set_agent_debug() {
-       echo -e $BOLD"Setting agent debug"$EBOLD
-       curl $LOCALHOST$POLICY_AGENT_EXTERNAL_PORT/actuator/loggers/org.oransc.policyagent -X POST  -H 'Content-Type: application/json' -d '{"configuredLevel":"debug"}' &> /dev/null
+       echo -e $BOLD"Setting agent debug logging"$EBOLD
+       actuator="/actuator/loggers/org.oransc.policyagent"
+       if [[ $POLICY_AGENT_IMAGE = *"onap"* ]]; then
+               actuator="/actuator/loggers/org.onap.ccsdk.oran.a1policymanagementservice"
+       fi
+       curlString="$LOCALHOST$POLICY_AGENT_EXTERNAL_PORT$actuator -X POST  -H Content-Type:application/json -d {\"configuredLevel\":\"debug\"}"
+       result=$(__do_curl "$curlString")
        if [ $? -ne 0 ]; then
                __print_err "could not set debug mode" $@
+               ((RES_CONF_FAIL++))
                return 1
        fi
        echo ""
@@ -1539,10 +1943,16 @@ set_agent_debug() {
 # args: -
 # (Function for test scripts)
 set_agent_trace() {
-       echo -e $BOLD"Setting agent trace"$EBOLD
-       curl $LOCALHOST$POLICY_AGENT_EXTERNAL_PORT/actuator/loggers/org.oransc.policyagent -X POST  -H 'Content-Type: application/json' -d '{"configuredLevel":"trace"}' &> /dev/null
+       echo -e $BOLD"Setting agent trace logging"$EBOLD
+       actuator="/actuator/loggers/org.oransc.policyagent"
+       if [[ $POLICY_AGENT_IMAGE = *"onap"* ]]; then
+               actuator="/actuator/loggers/org.onap.ccsdk.oran.a1policymanagementservice"
+       fi
+       curlString="$LOCALHOST$POLICY_AGENT_EXTERNAL_PORT$actuator -X POST  -H Content-Type:application/json -d {\"configuredLevel\":\"trace\"}"
+       result=$(__do_curl "$curlString")
        if [ $? -ne 0 ]; then
                __print_err "could not set trace mode" $@
+               ((RES_CONF_FAIL++))
                return 1
        fi
        echo ""
@@ -1559,6 +1969,150 @@ use_agent_retries() {
        return
 }
 
+###########################
+### ECS functions
+###########################
+
+# Start the ECS
+# args: -
+# (Function for test scripts)
+start_ecs() {
+
+       echo -e $BOLD"Starting ECS"$EBOLD
+
+       curdir=$PWD
+       cd $SIM_GROUP
+       cd ecs
+       cd $ECS_HOST_MNT_DIR
+       if [ -d database ]; then
+               if [ "$(ls -A $DIR)" ]; then
+                       echo -e $BOLD" Cleaning files in mounted dir: $PWD/database"$EBOLD
+                       rm -rf database/*  &> /dev/null
+                       if [ $? -ne 0 ]; then
+                               echo -e $RED" Cannot remove database files in: $PWD"$ERED
+                               exit 1
+                       fi
+               fi
+       else
+               echo " No files in mounted dir or dir does not exists"
+       fi
+       cd $curdir
+
+       __check_included_image 'ECS'
+       if [ $? -eq 1 ]; then
+               echo -e $RED"The ECS image has not been checked for this test run due to arg to the test script"$ERED
+               echo -e $RED"ECS will not be started"$ERED
+               exit
+       fi
+       export ECS_CERT_MOUNT_DIR="./cert"
+       __start_container ecs NODOCKERARGS $ECS_APP_NAME $ECS_EXTERNAL_PORT "/status" "http"
+}
+
+# Restart ECS
+# args: -
+# (Function for test scripts)
+restart_ecs() {
+       echo -e $BOLD"Re-starting ECS"$EBOLD
+       docker restart $ECS_APP_NAME &> ./tmp/.dockererr
+       if [ $? -ne 0 ]; then
+               __print_err "Could restart $ECS_APP_NAME" $@
+               cat ./tmp/.dockererr
+               ((RES_CONF_FAIL++))
+               return 1
+       fi
+
+       __check_container_start $ECS_APP_NAME $ECS_EXTERNAL_PORT "/status" "http"
+       echo ""
+       return 0
+}
+
+# All calls to ECS will be directed to the ECS REST interface from now on
+# args: -
+# (Function for test scripts)
+use_ecs_rest_http() {
+       echo -e $BOLD"ECS protocol setting"$EBOLD
+       echo -e " Using $BOLD http $EBOLD and $BOLD REST $EBOLD towards ECS"
+       export ECS_ADAPTER=$ECS_RESTBASE
+       echo ""
+}
+
+# All calls to ECS will be directed to the ECS REST interface from now on
+# args: -
+# (Function for test scripts)
+use_ecs_rest_https() {
+       echo -e $BOLD"ECS protocol setting"$EBOLD
+       echo -e " Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards ECS"
+       export ECS_ADAPTER=$ECS_RESTBASE_SECURE
+       echo ""
+       return 0
+}
+
+# All calls to ECS will be directed to the ECS dmaap interface over http from now on
+# args: -
+# (Function for test scripts)
+use_ecs_dmaap_http() {
+       echo -e $BOLD"ECS dmaap protocol setting"$EBOLD
+       echo -e $RED" - NOT SUPPORTED - "$ERED
+       echo -e " Using $BOLD http $EBOLD and $BOLD DMAAP $EBOLD towards ECS"
+       export ECS_ADAPTER=$ECS_DMAAPBASE
+       echo ""
+       return 0
+}
+
+# All calls to ECS will be directed to the ECS dmaap interface over https from now on
+# args: -
+# (Function for test scripts)
+use_ecs_dmaap_https() {
+       echo -e $BOLD"RICSIM protocol setting"$EBOLD
+       echo -e $RED" - NOT SUPPORTED - "$ERED
+       echo -e " Using $BOLD https $EBOLD and $BOLD REST $EBOLD towards ECS"
+       export ECS_ADAPTER=$ECS_DMAAPBASE_SECURE
+       echo ""
+       return 0
+}
+
+# Turn on debug level tracing in ECS
+# args: -
+# (Function for test scripts)
+set_ecs_debug() {
+       echo -e $BOLD"Setting ecs debug logging"$EBOLD
+       curlString="$LOCALHOST$ECS_EXTERNAL_PORT/actuator/loggers/org.oransc.enrichment -X POST  -H Content-Type:application/json -d {\"configuredLevel\":\"debug\"}"
+       result=$(__do_curl "$curlString")
+       if [ $? -ne 0 ]; then
+               __print_err "Could not set debug mode" $@
+               ((RES_CONF_FAIL++))
+               return 1
+       fi
+       echo ""
+       return 0
+}
+
+# Turn on trace level tracing in ECS
+# args: -
+# (Function for test scripts)
+set_ecs_trace() {
+       echo -e $BOLD"Setting ecs trace logging"$EBOLD
+       curlString="$LOCALHOST$ECS_EXTERNAL_PORT/actuator/loggers/org.oransc.enrichment -X POST  -H Content-Type:application/json -d {\"configuredLevel\":\"trace\"}"
+       result=$(__do_curl "$curlString")
+       if [ $? -ne 0 ]; then
+               __print_err "Could not set trace mode" $@
+               ((RES_CONF_FAIL++))
+               return 1
+       fi
+       echo ""
+       return 0
+}
+
+# Perform curl retries when making direct call to ECS for the specified http response codes
+# Speace separated list of http response codes
+# args: [<response-code>]*
+use_agent_retries() {
+       echo -e $BOLD"Do curl retries to the ECS REST inteface for these response codes:$@"$EBOLD
+       ECS_AGENT_RETRY_CODES=$@
+       echo ""
+       return
+}
+
 #################
 ### Log functions
 #################
@@ -1568,17 +2122,28 @@ use_agent_retries() {
 # (Function for test scripts)
 
 check_policy_agent_logs() {
-       __check_container_logs "Policy Agent" $POLICY_AGENT_APP_NAME $POLICY_AGENT_LOGPATH
+       __check_container_logs "Policy Agent" $POLICY_AGENT_APP_NAME $POLICY_AGENT_LOGPATH WARN ERR
+}
+
+check_ecs_logs() {
+       __check_container_logs "ECS" $ECS_APP_NAME $ECS_LOGPATH WARN ERR
 }
 
 check_control_panel_logs() {
-       __check_container_logs "Control Panel" $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_LOGPATH
+       __check_container_logs "Control Panel" $CONTROL_PANEL_APP_NAME $CONTROL_PANEL_LOGPATH WARN ERR
+}
+
+check_sdnc_logs() {
+       __check_container_logs "SDNC A1 Controller" $SDNC_APP_NAME $SDNC_KARAF_LOG WARN ERROR
 }
 
 __check_container_logs() {
        dispname=$1
        appname=$2
        logpath=$3
+       warning=$4
+       error=$5
+
        echo -e $BOLD"Checking $dispname container $appname log ($logpath) for WARNINGs and ERRORs"$EBOLD
 
        #tmp=$(docker ps | grep $appname)
@@ -1587,7 +2152,7 @@ __check_container_logs() {
                echo $dispname" is not running, no check made"
                return
        fi
-       foundentries="$(docker exec -it $tmp grep WARN $logpath | wc -l)"
+       foundentries="$(docker exec -t $tmp grep $warning $logpath | wc -l)"
        if [ $? -ne  0 ];then
                echo "  Problem to search $appname log $logpath"
        else
@@ -1597,7 +2162,7 @@ __check_container_logs() {
                        echo -e "  Found \033[1m"$foundentries"\033[0m WARN entries in $appname log $logpath"
                fi
        fi
-       foundentries="$(docker exec -it $tmp grep ERR $logpath | wc -l)"
+       foundentries="$(docker exec -t $tmp grep $error $logpath | wc -l)"
        if [ $? -ne  0 ];then
                echo "  Problem to search $appname log $logpath"
        else
@@ -1620,47 +2185,91 @@ store_logs() {
        __print_err "need one arg, <file-prefix>" $@
                exit 1
        fi
-       echo -e $BOLD"Storing all container logs, Policy Agent app log and consul config using prefix: "$1$EBOLD
+       echo -e $BOLD"Storing all container logs in $TESTLOGS/$ATC using prefix: "$1$EBOLD
 
        docker stats --no-stream > $TESTLOGS/$ATC/$1_docker_stats.log 2>&1
-       docker logs $CONSUL_APP_NAME > $TESTLOGS/$ATC/$1_consul.log 2>&1
-       docker logs $CBS_APP_NAME > $TESTLOGS/$ATC/$1_cbs.log 2>&1
-       docker logs $POLICY_AGENT_APP_NAME > $TESTLOGS/$ATC/$1_policy-agent.log 2>&1
-       docker logs $CONSUL_APP_NAME > $TESTLOGS/$ATC/$1_control-panel.log 2>&1
-       docker logs $MR_APP_NAME > $TESTLOGS/$ATC/$1_mr.log 2>&1
-       docker logs $CR_APP_NAME > $TESTLOGS/$ATC/$1_cr.log 2>&1
+
+       __check_included_image 'CONSUL'
+       if [ $? -eq 0 ]; then
+               docker logs $CONSUL_APP_NAME > $TESTLOGS/$ATC/$1_consul.log 2>&1
+       fi
+
+       __check_included_image 'CBS'
+       if [ $? -eq 0 ]; then
+               docker logs $CBS_APP_NAME > $TESTLOGS/$ATC/$1_cbs.log 2>&1
+               body="$(__do_curl $LOCALHOST$CBS_EXTERNAL_PORT/service_component_all/$POLICY_AGENT_APP_NAME)"
+               echo "$body" > $TESTLOGS/$ATC/$1_consul_config.json 2>&1
+       fi
+
+       __check_included_image 'PA'
+       if [ $? -eq 0 ]; then
+               docker logs $POLICY_AGENT_APP_NAME > $TESTLOGS/$ATC/$1_policy-agent.log 2>&1
+       fi
+
+       __check_included_image 'ECS'
+       if [ $? -eq 0 ]; then
+               docker logs $ECS_APP_NAME > $TESTLOGS/$ATC/$1_ecs.log 2>&1
+       fi
+
+       __check_included_image 'CP'
+       if [ $? -eq 0 ]; then
+               docker logs $CONTROL_PANEL_APP_NAME > $TESTLOGS/$ATC/$1_control-panel.log 2>&1
+       fi
+
+       __check_included_image 'MR'
+       if [ $? -eq 0 ]; then
+               docker logs $MR_APP_NAME > $TESTLOGS/$ATC/$1_mr.log 2>&1
+       fi
+
+       __check_included_image 'CR'
+       if [ $? -eq 0 ]; then
+               docker logs $CR_APP_NAME > $TESTLOGS/$ATC/$1_cr.log 2>&1
+       fi
+
        cp .httplog_${ATC}.txt $TESTLOGS/$ATC/$1_httplog_${ATC}.txt 2>&1
 
-       docker exec -it $SDNC_APP_NAME cat $SDNC_KARAF_LOG> $TESTLOGS/$ATC/$1_SDNC_karaf.log 2>&1
+       __check_included_image 'SDNC'
+       if [ $? -eq 0 ]; then
+               docker exec -t $SDNC_APP_NAME cat $SDNC_KARAF_LOG> $TESTLOGS/$ATC/$1_SDNC_karaf.log 2>&1
+       fi
 
-       docker exec -it $SDNC_ONAP_APP_NAME cat $SDNC_ONAP_KARAF_LOG > $TESTLOGS/$ATC/$1_SDNC_ONAP_karaf.log 2>&1
+       __check_included_image 'RICSIM'
+       if [ $? -eq 0 ]; then
+               rics=$(docker ps -f "name=$RIC_SIM_PREFIX" --format "{{.Names}}")
+               for ric in $rics; do
+                       docker logs $ric > $TESTLOGS/$ATC/$1_$ric.log 2>&1
+               done
+       fi
+
+       __check_included_image 'PRODSTUB'
+       if [ $? -eq 0 ]; then
+               docker logs $PROD_STUB_APP_NAME > $TESTLOGS/$ATC/$1_prodstub.log 2>&1
+       fi
 
-       rics=$(docker ps -f "name=$RIC_SIM_PREFIX" --format "{{.Names}}")
-       for ric in $rics; do
-               docker logs $ric > $TESTLOGS/$ATC/$1_$ric.log 2>&1
-       done
-       body="$(__do_curl $LOCALHOST$CBS_EXTERNAL_PORT/service_component_all/$POLICY_AGENT_APP_NAME)"
-       echo "$body" > $TESTLOGS/$ATC/$1_consul_config.json 2>&1
        echo ""
 }
 
 ###############
 ## Generic curl
 ###############
-# Generic curl function, assumed all 200-codes are ok
-# args: <url>
+# Generic curl function, assumes all 200-codes are ok
+# args: <valid-curl-args-including full url>
 # returns: <returned response (without respose code)>  or "<no-response-from-server>" or "<not found, <http-code>>""
 # returns: The return code is 0 for ok and 1 for not ok
 __do_curl() {
        echo ${FUNCNAME[1]} "line: "${BASH_LINENO[1]} >> $HTTPLOG
-       curlString="curl -skw %{http_code} $1"
+       curlString="curl -skw %{http_code} $@"
        echo " CMD: $curlString" >> $HTTPLOG
        res=$($curlString)
        echo " RESP: $res" >> $HTTPLOG
        http_code="${res:${#res}-3}"
        if [ ${#res} -eq 3 ]; then
-               echo "<no-response-from-server>"
-               return 1
+               if [ $http_code -lt 200 ] || [ $http_code -gt 299 ]; then
+                       echo "<no-response-from-server>"
+                       return 1
+               else
+                       return 0
+               fi
        else
                if [ $http_code -lt 200 ] || [ $http_code -gt 299 ]; then
                        echo "<not found, resp:${http_code}>"
@@ -1696,8 +2305,9 @@ __var_test() {
                        checkjsonarraycount=1
                fi
 
-               echo -e $BOLD"TEST(${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5} within ${6} seconds"$EBOLD
+               echo -e $BOLD"TEST $TEST_SEQUENCE_NR (${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5} within ${6} seconds"$EBOLD
                ((RES_TEST++))
+               ((TEST_SEQUENCE_NR++))
                start=$SECONDS
                ctr=0
                for (( ; ; )); do
@@ -1709,8 +2319,8 @@ __var_test() {
                                path=${3:5}
                                result="$(__do_curl $2$path)"
                                retcode=$?
-                               echo "$result" > .tmp.curl.json
-                               result=$(python3 ../common/count_json_elements.py ".tmp.curl.json")
+                               echo "$result" > ./tmp/.tmp.curl.json
+                               result=$(python3 ../common/count_json_elements.py "./tmp/.tmp.curl.json")
                        fi
                        duration=$((SECONDS-start))
                        echo -ne " Result=${result} after ${duration} seconds${SAMELINE}"
@@ -1757,8 +2367,9 @@ __var_test() {
                        checkjsonarraycount=1
                fi
 
-               echo -e $BOLD"TEST(${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5}"$EBOLD
+               echo -e $BOLD"TEST $TEST_SEQUENCE_NR (${BASH_LINENO[1]}): ${1}, ${3} ${4} ${5}"$EBOLD
                ((RES_TEST++))
+               ((TEST_SEQUENCE_NR++))
                if [ $checkjsonarraycount -eq 0 ]; then
                        result="$(__do_curl $2$3)"
                        retcode=$?
@@ -1767,8 +2378,8 @@ __var_test() {
                        path=${3:5}
                        result="$(__do_curl $2$path)"
                        retcode=$?
-                       echo "$result" > .tmp.curl.json
-                       result=$(python3 ../common/count_json_elements.py ".tmp.curl.json")
+                       echo "$result" > ./tmp/.tmp.curl.json
+                       result=$(python3 ../common/count_json_elements.py "./tmp/.tmp.curl.json")
                fi
                if [ $retcode -ne 0 ]; then
                        ((RES_FAIL++))
@@ -1801,22 +2412,6 @@ __var_test() {
 
 ### Generic test cases for varaible checking
 
-# Tests if a variable value in the CR is equal to a target value and and optional timeout.
-# Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
-# equal to the target or not.
-# Arg: <variable-name> <target-value> <timeout-in-sec>  - This test waits up to the timeout seconds
-# before setting pass or fail depending on if the variable value becomes equal to the target
-# value or not.
-# (Function for test scripts)
-cr_equal() {
-       if [ $# -eq 2 ] || [ $# -eq 3 ]; then
-               __var_test "CR" "$LOCALHOST$CR_EXTERNAL_PORT/counter/" $1 "=" $2 $3
-       else
-               ((RES_CONF_FAIL++))
-               __print_err "Wrong args to cr_equal, needs two or three args: <sim-param> <target-value> [ timeout ]" $@
-       fi
-}
-
 # Tests if a variable value in the MR stub is equal to a target value and and optional timeout.
 # Arg: <variable-name> <target-value> - This test set pass or fail depending on if the variable is
 # equal to the target or not.